import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopArticle, ShopArticleParam } from './model';

/**
 * 分页查询商品文章
 */
export async function pageShopArticle(params: ShopArticleParam) {
  const res = await request.get<ApiResult<PageResult<ShopArticle>>>(
    '/shop/shop-article/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商品文章列表
 */
export async function listShopArticle(params?: ShopArticleParam) {
  const res = await request.get<ApiResult<ShopArticle[]>>(
    '/shop/shop-article',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商品文章
 */
export async function addShopArticle(data: ShopArticle) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-article',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商品文章
 */
export async function updateShopArticle(data: ShopArticle) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-article',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商品文章
 */
export async function removeShopArticle(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-article/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商品文章
 */
export async function removeBatchShopArticle(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-article/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商品文章
 */
export async function getShopArticle(id: number) {
  const res = await request.get<ApiResult<ShopArticle>>(
    '/shop/shop-article/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
